'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * This class represents the event that gets dispatched by the
 * PluginManager.
 */
let Event = function () {
  /**
   * Create a new instance.
   *
   * @param {EventConfig} config         event configuration
   * @param {String}      config.name    event name
   * @param {Object}      config.context event context
   */
  function Event(config) {
    _classCallCheck(this, Event);

    this._name = config.name || 'event';
    this._context = config.context;
  }

  /**
   * Get event name.
   *
   * @returns {String} the event name
   */


  _createClass(Event, [{
    key: 'name',
    get: function get() {
      return this._name;
    }

    /**
     * Get event context.
     *
     * @returns {Object} the event context
     */

  }, {
    key: 'context',
    get: function get() {
      return this._context;
    }

    /**
     * Set event context.
     *
     * @param {Object} context the event context
     *
     * @returns {Event} this instance
     */
    ,
    set: function set(context) {
      this._context = context;

      return this;
    }
  }]);

  return Event;
}();

exports.default = Event;